#include "generate_utils.h"

int use_comm_total_flag = 0; //Use this flag to indicate that while generating max size function we need to use comm_total.
extern var_dump_t * var;
extern generator_context_t* h_gen_context;

/*Generates initial part of main.c*/
void generate_main_c_header(FILE * skel_fh){
  fprintf(skel_fh, "#include <stdio.h>\n");
  fprintf(skel_fh, "#include <stdlib.h>\n");
  fprintf(skel_fh, "#include <string.h>\n");
  fprintf(skel_fh, "#include <mpi.h>\n");
  fprintf(skel_fh, "#include \"main.h\"\n");
  fprintf(skel_fh, "#include \"util.h\"\n\n");
  fprintf(skel_fh, "int main(int argc, char *argv[]) {\n");
  //printindent(skel_fh);
  //fprintf(skel_fh, "DEFINE_FH\n");
  printindent(skel_fh);
  fprintf(skel_fh, "int myrank;\n");
  printindent(skel_fh);
  fprintf(skel_fh, "int comm_size;\n");
  printindent(skel_fh);
  fprintf(skel_fh, "int buffersize = 0;\n");
  printindent(skel_fh);
  /*
   *TODO: can we use one buffer instead two i.e. buffer,buffer2??
   */
  fprintf(skel_fh, "void* buffer = NULL;\n");
  printindent(skel_fh);
  fprintf(skel_fh, "void* buffer2 = NULL;\n");
  printindent(skel_fh);
  fprintf(skel_fh, "struct timeval tv, tv1;\n");
  printindent(skel_fh);
  fprintf(skel_fh, "MPI_Request request, *requests;\n");
  printindent(skel_fh);
  fprintf(skel_fh, "MPI_Status status, *statuses;\n");
  printindent(skel_fh);
  fprintf(skel_fh, "int *temp_int_array;\n");
  printindent(skel_fh);
  fprintf(skel_fh, "int current = 0;\n");          
  printindent(skel_fh);
  fprintf(skel_fh, "req_handler_t req;\n");  
  printindent(skel_fh);
  fprintf(skel_fh, "init_req(&req,10000);\n");
  printindent(skel_fh);
  fprintf(skel_fh, "comm_handler_t communicators;\n");
  printindent(skel_fh);
  fprintf(skel_fh, "init_comm(&communicators, 10000);\n");
  printindent(skel_fh);
  fprintf(skel_fh, "init_params();\n");
}

/*Generates closing part of main.c*/
void generate_main_c_end(FILE * skel_fh){
  printindent(skel_fh);
  fprintf(skel_fh, "if(buffersize > 0) {\n");
  indent++;
  printindent(skel_fh);
  fprintf(skel_fh, "free(buffer); free(buffer2);\n");
  indent--;
  printindent(skel_fh);
  fprintf(skel_fh, "}\n");
  //printindent(skel_fh);
  //fprintf(skel_fh, "free_skel_rank();\n");
  printindent(skel_fh);
  fprintf(skel_fh, "finalize_req(req);\n");
  printindent(skel_fh);
  fprintf(skel_fh, "free_params();\n");
  printindent(skel_fh);
  fprintf(skel_fh, "free_comm(&communicators);\n");
  //Writing the total time taken to 0 rank process
  printindent(skel_fh);
  fprintf(skel_fh,"if(myrank==0) {\n");
  indent++;
  printindent(skel_fh);
  fprintf(skel_fh, "if(tv1.tv_usec < tv.tv_usec){\n");
  indent++;
  printindent(skel_fh);
  fprintf(skel_fh, "printf(\"time: %%d.%%d\\n\", tv1.tv_sec - tv.tv_sec - 1, tv1.tv_usec + 1000000 - tv.tv_usec);\n");
  indent--;
  printindent(skel_fh);
  fprintf(skel_fh, "} else {\n");
  indent++;
  printindent(skel_fh);
  fprintf(skel_fh, "printf(\"time: %%d.%%d\\n\", tv1.tv_sec - tv.tv_sec, tv1.tv_usec - tv.tv_usec);\n");
  indent--;
  printindent(skel_fh);
  fprintf(skel_fh, "}\n");
    
  indent--;
  printindent(skel_fh);
  fprintf(skel_fh,"}\n");
  printindent(skel_fh);
  fprintf(skel_fh,"return 0;\n");
  fprintf(skel_fh,"}\n");
}

/**
 * by Xing WU
 */
void generate_util_h(FILE *skel_type_fh){
  fprintf(skel_type_fh, "#ifndef UTIL_H\n");
  fprintf(skel_type_fh, "#define UTIL_H\n\n");

  fprintf(skel_type_fh, "#include <time.h>\n");
  fprintf(skel_type_fh, "#include <sys/time.h>\n");
  fprintf(skel_type_fh, "#include <stdio.h>\n");
  fprintf(skel_type_fh, "#include <stdlib.h>\n");
  fprintf(skel_type_fh, "#include <limits.h>\n");
  fprintf(skel_type_fh, "#include <string.h>\n");
  fprintf(skel_type_fh, "#include <assert.h>\n");
  fprintf(skel_type_fh, "#include <mpi.h>\n\n\n");

  //global variabled in util.h
  fprintf(skel_type_fh, "\
int *cur_iter;\n\
int *iters_len;\n\
int *cur_mems;\n\
int *mems_len;\n\
");

  fprintf(skel_type_fh, "\ntypedef struct req_handler{\n");
  fprintf(skel_type_fh, "\tMPI_Request *req_buf;\n");
  fprintf(skel_type_fh, "\tMPI_Status  *statuses;\n");
  fprintf(skel_type_fh, "\tint req_bufsize;\n");
  fprintf(skel_type_fh, "\tint req_bufcur;\n");
  fprintf(skel_type_fh, "} * req_handler_t;\n\n\n");

  fprintf(skel_type_fh, "\
typedef struct comm_handler{\n\
\tMPI_Comm *comms;\n\
\tint count;\n\
\tint size;\n\
} comm_handler_t;\n\n\n\
");

  fprintf(skel_type_fh, "\
typedef struct event_time{\n\
\tint prev_event;\n\
\tlong long time;\n\
} event_time_t;\n\n\n\
");

  //structures for params
  fprintf(skel_type_fh, "\
typedef struct {\n\
\tint * val;\n\
\tint iter;\n\
} param_t;\n\n\n\
typedef enum {\n\
\tSOURCE = 0,\n\
\tDEST,\n\
\tCOUNT,\n\
\tREQUEST,\n\
\tCOLOR,\n\
\tKEY,\n\
\tMAX_PARAM_TYPE\n\
}param_type_t;\n\n\n\
typedef struct {\n\
\tparam_t param[MAX_PARAM_TYPE];\n\
}event_param_t;\n\n\n\
");

  fprintf(skel_type_fh, "\
void init_params();\n\
void free_params();\n\
int* get_param_val_list(int rank, char* val_str);\n\
int get_param_val(int rank, char* val_str, param_t* event_param);\n\
int get_iters_length(int rank, char* val_str, int loop_idx, int loop_depth);\n\
int get_mems_length(int rank, char* val_str, int loop_idx, int loop_depth);\n\
int get_max_size();\n\
void do_compute(int cur_event, event_time_t* event_times, int length);\n\
int *parse_val_str(char *buf);\n\
int member_rank_helper(int rank_target, int *list, int start, int depth);\n\
int is_member(int rank, char *buf);\n\
int unroll_is_member(int rank, char *buf);\n\
int is_memb(int rank, int *list);\n\
int is_loop_member(int rank, char* buf, int loop_depth);\n\
void update_mem_cnts(int close_depth);\n\
void init_req(req_handler_t *r, int size);\n\
int add_request(req_handler_t req);\n\
void find_requests(req_handler_t req, int count, int *indices, MPI_Request **requests);\n\
int reset_req(req_handler_t req, int *req_indices, int count);\n\
void finalize_req(req_handler_t req);\n\
void init_comm(comm_handler_t *cm, int size);\n\
MPI_Comm* get_next_comm(comm_handler_t *cm);\n\
MPI_Comm get_comm(comm_handler_t *cm, int index);\n\
MPI_Comm* get_comm_pointer(comm_handler_t *cm, int index);\n\
void free_comm(comm_handler_t *cm);\n\
void do_isend(void* buffer, MPI_Datatype datatype, char* ccounts, char* cdests, int tag, MPI_Comm comm, req_handler_t req, int myrank, int comm_size);\n\
void do_send(void* buffer, MPI_Datatype datatype, char* ccounts, char* cdests, int tag, MPI_Comm comm, int myrank, int comm_size);\n\
void do_irecv(void* buffer, MPI_Datatype datatype, char* ccounts,  char* csources, int tag, MPI_Comm comm, req_handler_t req, int myrank, int comm_size);\n\
void do_recv(void* buffer, MPI_Datatype datatype, char* ccounts, char* csources, int tag, MPI_Comm comm, MPI_Status *status, int myrank, int comm_size);\n\
void do_waitall(char *cwaits, req_handler_t req, int myrank);\n\
void do_wait(char *cwaits, req_handler_t req, int myrank);\n\
void do_reduce(void *sendbuf, void* recvbuf, char *ccounts, MPI_Datatype datatype, MPI_Op op, int root, MPI_Comm comm, int myrank);\n\
void do_allreduce(void *sendbuf, void* recvbuf, char *ccounts, MPI_Datatype datatype, MPI_Op op, MPI_Comm comm, int myrank);\n\
void do_bcast(void *buffer, char *ccounts, MPI_Datatype datatype, int root, MPI_Comm comm, int myrank);\n\
void do_comm_split(MPI_Comm comm, char* ccolors, char* ckeys, MPI_Comm *newcomm, int myrank);\n\n\
");

  fprintf(skel_type_fh, "#endif\n");
}

void generate_util_h_parse_once_params(FILE *skel_type_fh, int length){
  fprintf(skel_type_fh, "\n\n\
typedef struct parse_once_param{\n\
\tint *count_vector;\n\
} parse_once_param_t;\n\n\
void parse_once(char *count_string, int trip_count, int myrank, int index);\n\
void free_parse_once_params();\n\n\
static parse_once_param_t parse_once_parameters[%d];\n\n\
", length);

}

void generate_util_c_header(FILE *skel_type_fh){
  fprintf(skel_type_fh, "#include \"util.h\"\n\n\n");

  fprintf(skel_type_fh, "\
#define MAX_NUM_EVENTS %d\n\
#define MAX_NUM_LOOPS %d\n\
#define MAX_LOOP_DEPTH 100\n\
#define RL_SEPARATOR ','\n\
#define PARAM_ENTRY_SEPARATOR ';'\n\n\
", 
h_gen_context->event_count, h_gen_context->loop_count
);

  fprintf(skel_type_fh, "\
int prev_event = 0;\n\
event_param_t* event_params;\n\
param_t* loops;\n\
param_t* mems;\n\
");
}

void generate_util_compute_time_function(FILE *skel_type_fh){
  //using usleep for computation
  fprintf(skel_type_fh, "\
\n\nstatic void compute(long long delay) {\n\
#ifndef FEATURE_USE_SLEEP\n\
\tstruct timeval param, begin, now, rem;\n\
\tint second = delay / 1000000;\n\
\tint microsecond = delay % 1000000;\n\
\tparam.tv_sec = second;\n\
\tparam.tv_usec = microsecond;\n\
\tgettimeofday (&begin, NULL);\n\
\ttimeradd (&begin, &param, &param);\n\
\trem.tv_sec = 0;\n\
\trem.tv_usec = 0;\n\
\twhile (rem.tv_sec >= 0){\n\
\t\tgettimeofday (&now, NULL);\n\
\t\ttimersub (&param, &now, &rem);\n\
\t}\n\
#else\n\
\tusleep(delay);\n\
#endif\n\
}\n\
");

  fprintf(skel_type_fh, "\
\n\nvoid do_compute(int cur_event, event_time_t* event_times, int length){\n\
\tint idx = 0;\n\
\tfor(idx = 0; idx < length; idx++){\n\
\t\tif(event_times[idx].prev_event == prev_event){\n\
\t\t\tbreak;\n\
\t\t}\n\
\t}\n\
\tassert(idx < length);\n\
\tcompute(event_times[idx].time);\n\
\tprev_event = cur_event;\n\
}\n\
");
}

void generate_max_size_function(FILE* skel_type_fh, derived_type_dump_t* type) {
  int i=0;
  extern int comm_total;
  //TODO: the get_max_size function should be fixed, the max value should 
  //be calculated when traversing the trace
  fprintf(skel_type_fh, "\nint get_max_size() {\n");
  /*fprintf(skel_type_fh, "\tint value = 0;\n\tMPI_Aint size = 0;\n");

  if(type != NULL && type->total_count > 0) {
    for(i=0;i<type->total_count;i++) {
      if(type->type_usage_count[i]>0) {
        fprintf(skel_type_fh, "\tMPI_Type_extent(%s,&size);\n",type->type_name[i]);
        fprintf(skel_type_fh, "\tif(value < (%d * size)) value += %d*size;\n", type->type_usage_count[i],type->type_usage_count[i]);
      }
    }
  }

  if(use_comm_total_flag==0)
    fprintf(skel_type_fh, "\treturn value;\n");
  else
    fprintf(skel_type_fh, "\treturn %d * value;\n",comm_total);*/
  fprintf(skel_type_fh, "return %d;\n", 1 << 29);
  fprintf(skel_type_fh, "}\n");

  /* commented by Xing
  fprintf(skel_type_fh, "\n\nvoid skel_sleep(long long sec, long long nsec) {\n");
  fprintf(skel_type_fh, "\tstruct timeval param, begin, now, rem;\n");
  fprintf(skel_type_fh, "\tparam.tv_sec = sec;\n");
  fprintf(skel_type_fh, "\tparam.tv_usec = nsec/1000;\n");
  fprintf(skel_type_fh, "\tgettimeofday (&begin, NULL);\n");
  fprintf(skel_type_fh, "\ttimeradd (&begin, &param, &param);\n");
  fprintf(skel_type_fh, "\trem.tv_sec = 0;\n");
  fprintf(skel_type_fh, "\trem.tv_usec = 0;\n");
  fprintf(skel_type_fh, "\twhile (rem.tv_sec >= 0){\n");
  fprintf(skel_type_fh, "\t\tgettimeofday (&now, NULL);\n");
  fprintf(skel_type_fh, "\t\ttimersub (&param, &now, &rem);\n");
  fprintf(skel_type_fh, "\t}\n");
  //fprintf(skel_type_fh, "struct timespec ts;\n");
  //fprintf(skel_type_fh, "ts.tv_sec = sec;\n");
  //fprintf(skel_type_fh, "ts.tv_nsec = nsec;\n");
  //fprintf(skel_type_fh, "nanosleep(&ts, NULL);\n");
  fprintf(skel_type_fh, "}\n");
  */
}

void generate_is_member_function(FILE *skel_type_fh){	
  fprintf(skel_type_fh, "\
\n\nint *parse_val_str(char *buf) {\n\
\tchar *start_pos = buf, *iter;\n\
\tint i;\n\
\twhile (*start_pos == ' ') start_pos++;\n\
\tint len = 1;\n\
\tfor (iter = start_pos + 1; ; iter++) {\n\
\t\tif (*iter == ' ') {\n\
\t\t\tlen++;\n\
\t\t\tcontinue;\n\
\t\t}\n\
\t\tif ((*iter < '0' || *iter > '9') && *iter != '-') {\n\
\t\t\tbreak;\n\
\t\t}\n\
\t}\n\
\tint *rlist = (int*)malloc(sizeof(int) * len);\n\
\tif(!rlist)\n\
\t\texit(1);\n\
\tint num_prsds;\n\
\tsscanf(start_pos, \"%%d\", &num_prsds);\n\
\trlist[0] = num_prsds;\n\
\tstart_pos = strchr(start_pos, ' ') + 1;\n\
\tfor(i = 1; i < len; i++) {\n\
\t\tsscanf(start_pos, \"%%d\", &rlist[i]);\n\
\t\tstart_pos = strchr(start_pos, ' ') + 1;\n\
\t}\n\
\treturn rlist;\n\
}\n\
");

  fprintf(skel_type_fh, "\
\n\nint member_rank_helper(int rank_target, int *list, int start, int depth){\n\
\tint i, rank, iters, stride;\n\
\tif(depth > -1) return 0;\n\
\titers = list[0];\n\
\tstride = list[1];\n\
\tfor(i = 0, rank = start; i < iters; i++, rank += stride) {\n\
\t\tif(rank == rank_target)\n\
\t\t\treturn 1;\n\
\t\tif(depth != -1) {\n\
\t\t\tif(member_rank_helper(rank_target, list + 2, rank, depth + 1))\n\
\t\t\t\treturn 1;\n\
\t\t}\n\
\t}\n\
\treturn 0;\n\
}\n\
");


  fprintf(skel_type_fh, "\
\n\nint is_member(int rank, char *buf){\n\
\tint *list = parse_val_str(buf);\n\
\tint rtn = is_memb(rank, list);\n\
\tfree(list);\n\
\treturn rtn;\n\
}\n\
");

  fprintf(skel_type_fh, "\
\n\nint unroll_is_member(int rank, char *buf){\n\
\tint *list = parse_val_str(buf);\n\
\tint i;\n\
\tfor(i=1; i<=list[0]; i++){\n\
\t\tif(list[i] == rank){\n\
\t\t\tfree(list);\n\
\t\t\treturn 1;\n\
\t\t}\n\
\t}\n\
\tfree(list);\n\
\treturn 0;\n\
}\n\
");

  fprintf(skel_type_fh, "\
\n\nint is_memb(int rank, int *list) {\n\
\tint pos, cur_prsd, depth, start;\n\
\tif(!list) return 0;\n\
\tpos = 1;\n\
\tcur_prsd = 0;\n\
\twhile(cur_prsd < list[0]) {\n\
\t\tdepth = list[pos];\n\
\t\tstart = list[pos + 1];\n\
\t\tpos += 2;\n\
\t\tif(member_rank_helper(rank, list + pos, start, depth)) {\n\
\t\t\treturn 1;\n\
\t\t}\n\
\t\tif(cur_prsd + 1 == list[0]) break;\n\
\t\tpos++;\n\
\t\twhile(list[pos] > 0) pos++;\n\
\t\tcur_prsd++;\n\
\t}\n\
\treturn 0;\n\
}\n\
");

  //is_loop_member function
  fprintf(skel_type_fh, "\
\n\nint is_loop_member(int rank, char* buf, int loop_depth){\n\
\tint rtn = 0;\n\
\tif(is_member(rank, buf)){\n\
\t\trtn = 1;\n\
\t\tint idx = 0;\n\
\t\tfor(idx = 0; idx < loop_depth; idx++){\n\
\t\t\tif(cur_mems[idx] >= mems_len[idx] &&\n\
\t\t\tcur_iter[idx] != iters_len[idx] - 1){\n\
\t\t\t\trtn = 0;\n\
\t\t\t\tbreak;\n\
\t\t\t}\n\
\t\t}\n\
\t}\n\
\tif(rtn){\n\
\t\tint idx = 0;\n\
\t\tfor(idx = 0; idx < loop_depth; idx++){\n\
\t\t\tcur_mems[idx]++;\n\
\t\t}\n\
\t}\n\
\treturn rtn;\n\
}\n\
");

  //update_mem_cnts function
  fprintf(skel_type_fh, "\
\n\nvoid update_mem_cnts(int closing_depth){\n\
\tif(cur_iter[closing_depth - 1] == iters_len[closing_depth - 1] - 1){\n\
\t\tcur_mems[closing_depth - 1] = 0;\n\
\t\treturn;\n\
\t}\n\
\tint idx = 0;\n\
\tfor(idx = 0; idx < closing_depth; idx++){\n\
\t\tcur_mems[idx] -= cur_mems[closing_depth - 1];\n\
\t}\n\
}\n\
");
}


/* The following function was implemented by Vivek and commented out by Xing.
 * The function above is the one in use!!!
 */
/*
void generate_is_member_function(FILE * skel_type_fh)
{
	fprintf(skel_type_fh,"int x=0;\n"); 
	fprintf(skel_type_fh,"int y =0;\n"); 
	fprintf(skel_type_fh,"int **rank_list;\n"); 
	fprintf(skel_type_fh,"void read_skel_rank() {\n");
	fprintf(skel_type_fh,"FILE *fp;\n"); 
	fprintf(skel_type_fh,"int cnt;\n"); 
	fprintf(skel_type_fh,"char *line;\n"); 
	fprintf(skel_type_fh,"char *ptr;\n"); 
	fprintf(skel_type_fh,"int i,j;\n"); 
	fprintf(skel_type_fh,"int tmp;\n"); 
	fprintf(skel_type_fh,"line=malloc(LINE_MAX*sizeof(char));\n"); 
	fprintf(skel_type_fh,"fp=fopen(\"skel_rank\",\"r\");\n"); 
	fprintf(skel_type_fh,"while(!feof(fp))\n"); 
	fprintf(skel_type_fh,"{\n"); 
	fprintf(skel_type_fh,"   fgets(line,LINE_MAX,fp);\n"); 
	fprintf(skel_type_fh,"   if(*line=='\\0')\n");
	fprintf(skel_type_fh,"    return;");
	fprintf(skel_type_fh,"   y++;\n"); 
	fprintf(skel_type_fh,"   ptr=line;\n"); 
	fprintf(skel_type_fh,"   cnt=0;\n"); 
	fprintf(skel_type_fh,"   while(*ptr!='\\n')\n"); 
	fprintf(skel_type_fh,"   {\n"); 
	fprintf(skel_type_fh,"      if(*ptr==\' \')\n"); 
	fprintf(skel_type_fh,"         cnt++;\n"); 
	fprintf(skel_type_fh,"      ptr++;\n"); 
	fprintf(skel_type_fh,"   }\n"); 
	fprintf(skel_type_fh,"   if(cnt > x)\n"); 
	fprintf(skel_type_fh,"      x = cnt;\n"); 
	fprintf(skel_type_fh,"}\n"); 
	fprintf(skel_type_fh,"y--;\n"); 
	fprintf(skel_type_fh,"fclose(fp);\n"); 
	fprintf(skel_type_fh,"fp=fopen(\"skel_rank\",\"r\");\n"); 
	fprintf(skel_type_fh,"rank_list=malloc(y*sizeof(int*));\n"); 
	fprintf(skel_type_fh,"for(i=0;i<y;i++)\n"); 
	fprintf(skel_type_fh,"  rank_list[i]=malloc(x*sizeof(int));\n"); 
	fprintf(skel_type_fh,"for(j=0;j<y;j++)\n"); 
	fprintf(skel_type_fh,"{\n"); 
	fprintf(skel_type_fh,"   fgets(line,LINE_MAX,fp);\n"); 
	fprintf(skel_type_fh,"   ptr= line;\n"); 
	fprintf(skel_type_fh,"   sscanf(ptr,\"%%d\",&tmp); \n"); 
	fprintf(skel_type_fh,"   while(*ptr!=\' \')\n"); 
	fprintf(skel_type_fh,"      ptr++;\n"); 
	fprintf(skel_type_fh,"   i=0;\n"); 
	fprintf(skel_type_fh,"   while(*ptr!=\'\\n\')\n"); 
	fprintf(skel_type_fh,"   {\n"); 
	fprintf(skel_type_fh,"     ptr++;\n"); 
	fprintf(skel_type_fh,"     sscanf(ptr,\"%%d\",&rank_list[j][i]); \n"); 
	fprintf(skel_type_fh,"     while(*ptr!=\' \')\n"); 
	fprintf(skel_type_fh,"     {\n"); 
	fprintf(skel_type_fh,"       ptr++;\n"); 
	fprintf(skel_type_fh,"       if(*ptr=='\\n')\n"); 
	fprintf(skel_type_fh,"         break;\n"); 
	fprintf(skel_type_fh,"     }\n"); 
	fprintf(skel_type_fh,"     i++;\n"); 
	fprintf(skel_type_fh,"   }\n"); 
	fprintf(skel_type_fh,"}\n"); 
	fprintf(skel_type_fh,"fclose(fp);\n"); 
	fprintf(skel_type_fh,"}\n"); 
	fprintf(skel_type_fh,"int is_member(int a,int rank)\n"); 
	fprintf(skel_type_fh,"{\n");   
	fprintf(skel_type_fh,"int event_number;\n"); 
	fprintf(skel_type_fh,"int no_ranklist;\n"); 
	fprintf(skel_type_fh,"int start;\n"); 
	fprintf(skel_type_fh,"int return_val=0; \n"); 
	fprintf(skel_type_fh,"int  depth, start_rank, stride, iters, i, j, k;\n"); 
	fprintf(skel_type_fh,"int flag = 0;\n"); 
	fprintf(skel_type_fh,"int ptr;\n"); 
	fprintf(skel_type_fh,"ptr=0;\n"); 
	fprintf(skel_type_fh,"no_ranklist = rank_list[a-1][ptr];\n"); 
	fprintf(skel_type_fh,"ptr++;\n"); 
	fprintf(skel_type_fh,"        for(k=0; k<no_ranklist; k++){\n"); 
	fprintf(skel_type_fh,"               flag=0;\n"); 
	fprintf(skel_type_fh,"               depth = rank_list[a-1][ptr];\n"); 
	fprintf(skel_type_fh,"               ptr++;\n"); 
	fprintf(skel_type_fh,"               depth = -depth;\n"); 
	fprintf(skel_type_fh,"               start_rank = rank_list[a-1][ptr];\n"); 
	fprintf(skel_type_fh,"               ptr++;\n"); 
	fprintf(skel_type_fh,"               if(rank==start_rank)\n"); 
	fprintf(skel_type_fh,"               {\n"); 
	fprintf(skel_type_fh,"                   return 1;\n"); 
	fprintf(skel_type_fh,"               }\n"); 
	fprintf(skel_type_fh,"               if(rank<start_rank)\n"); 
	fprintf(skel_type_fh,"               {\n"); 
	fprintf(skel_type_fh,"                   return 0;\n"); 
	fprintf(skel_type_fh,"               }\n"); 
	fprintf(skel_type_fh,"                start = start_rank;\n"); 
	fprintf(skel_type_fh,"                if(depth > 1)\n"); 
	fprintf(skel_type_fh,"                {\n"); 
	fprintf(skel_type_fh,"                   for(j=0; j<depth-1;j++){\n"); 
	fprintf(skel_type_fh,"                        iters = rank_list[a-1][ptr];\n"); 
	fprintf(skel_type_fh,"                        ptr++;\n"); 
	fprintf(skel_type_fh,"                        stride = rank_list[a-1][ptr];\n"); 
	fprintf(skel_type_fh,"                        ptr++;\n"); 
	fprintf(skel_type_fh,"                        for(i=start;i<=(start+((iters)*stride));i+=stride)\n"); 
	fprintf(skel_type_fh,"                        {\n"); 
	fprintf(skel_type_fh,"                            if(rank<i)\n"); 
	fprintf(skel_type_fh,"                            {\n"); 
	fprintf(skel_type_fh,"                                i-=stride;\n"); 
	fprintf(skel_type_fh,"                                break;\n"); 
	fprintf(skel_type_fh,"                            }\n"); 
	fprintf(skel_type_fh,"                        }\n"); 
	fprintf(skel_type_fh,"                        if(i>=(start+((iters)*stride)))\n");
	fprintf(skel_type_fh,"                            flag=1;            \n"); 
	fprintf(skel_type_fh,"                        start = i;\n"); 
	fprintf(skel_type_fh,"                    }\n"); 
	fprintf(skel_type_fh,"                 }\n"); 
	fprintf(skel_type_fh,"                        iters = rank_list[a-1][ptr];\n"); 
	fprintf(skel_type_fh,"                        ptr++;\n"); 
	fprintf(skel_type_fh,"                        stride = rank_list[a-1][ptr];\n"); 
	fprintf(skel_type_fh,"                        ptr++;\n"); 
	fprintf(skel_type_fh,"                 if(flag==1)\n"); 
	fprintf(skel_type_fh,"                   continue;   \n"); 
	fprintf(skel_type_fh,"                 if(stride > 1 && iters > 1) {\n"); 
	fprintf(skel_type_fh,"                    return_val = (((rank-start)%%stride==0) && (rank <= (start+((iters-1)*stride)))) ? 1 : 0;\n"); 
	fprintf(skel_type_fh,"                 }\n"); 
	fprintf(skel_type_fh,"                 else if(stride == 1 && iters > 1) {\n"); 
	fprintf(skel_type_fh,"                    return_val = (rank >= start && rank <=(start+((iters-1)*stride))) ? 1 : 0;\n"); 
	fprintf(skel_type_fh,"                 }\n"); 
	fprintf(skel_type_fh,"                 else if(stride == 0 && iters == 1) {\n"); 
	fprintf(skel_type_fh,"                    return_val = (rank == start) ? 1 : 0;\n"); 
	fprintf(skel_type_fh,"                 }\n"); 
	fprintf(skel_type_fh,"\n"); 
	fprintf(skel_type_fh,"                 if(return_val == 1)\n"); 
	fprintf(skel_type_fh,"                 {   \n"); 
	fprintf(skel_type_fh,"                    return return_val;\n"); 
	fprintf(skel_type_fh,"                 }  \n"); 
	fprintf(skel_type_fh,"        }\n"); 
	fprintf(skel_type_fh,"\n"); 
	fprintf(skel_type_fh,"return return_val;\n"); 
	fprintf(skel_type_fh,"}\n"); 
	fprintf(skel_type_fh,"void free_skel_rank()\n"); 
	fprintf(skel_type_fh,"{\n"); 
	fprintf(skel_type_fh,"int i= 0;\n"); 
	fprintf(skel_type_fh,"if(rank_list)\n"); 
	fprintf(skel_type_fh,"{\n"); 
	fprintf(skel_type_fh,"  for(i=0;i<y;i++)\n"); 
	fprintf(skel_type_fh,"  {\n"); 
	fprintf(skel_type_fh,"    free(rank_list[i]);\n"); 
	fprintf(skel_type_fh,"  }\n"); 
	fprintf(skel_type_fh,"  free(rank_list);\n"); 
	fprintf(skel_type_fh,"}\n"); 
	fprintf(skel_type_fh,"}\n"); 
}
*/


/**
 *
 * author: Xing Wu
 */
void generate_comm_handler_functions(FILE *skel_type_fh){

  fprintf(skel_type_fh, "\
\n\nvoid init_comm(comm_handler_t *cm, int size){\n\
\tint i;\n\
\tcm->comms = (MPI_Comm *)malloc(size * sizeof(MPI_Comm));\n\
\tfor(i=0; i<size; i++)\n\
\t\tcm->comms[i] = MPI_COMM_NULL;\n\
\tcm->count = 3;\n\
\tcm->size = size;\n\
\tcm->comms[0] = MPI_COMM_NULL;\n\
\tcm->comms[1] = MPI_COMM_SELF;\n\
\tcm->comms[2] = MPI_COMM_WORLD;\n\
}\n\
");



  fprintf(skel_type_fh, "\
\n\nMPI_Comm* get_next_comm(comm_handler_t *cm){\n\
\tif(cm->count == cm->size)\n\
\t\treturn NULL;\n\
\t(cm->count)++;\n\
\treturn cm->comms+cm->count-1;\n\
}\n\
");

  fprintf(skel_type_fh, "\
\n\nMPI_Comm get_comm(comm_handler_t *cm, int index){\n\
\tint real_index = index < 1000 ? index : index - 1000 + 3;\n\
\treturn cm->comms[real_index];\n\
}\n\
");

  fprintf(skel_type_fh, "\
\n\nMPI_Comm* get_comm_pointer(comm_handler_t *cm, int index){\n\
\tint real_index = index < 1000 ? index : index - 1000 + 3;\n\
\treturn cm->comms + real_index;\n\
}\n\
");

  fprintf(skel_type_fh, "\
\n\nvoid free_comm(comm_handler_t *cm){\n\
\tfree(cm->comms);\n\
\tcm->count = 0;\n\
\tcm->size = 0;\n\
}\n\
");
}


/**
 * author: Xing Wu
 */
void generate_req_handler_function(FILE* skel_type_fh){
	fprintf(skel_type_fh,"\n\n\n");
	fprintf(skel_type_fh,"void init_req(req_handler_t *r, int size){\n");
	fprintf(skel_type_fh,"\treq_handler_t req;\n");
	fprintf(skel_type_fh,"\tint i;\n");
	fprintf(skel_type_fh,"\treq = (req_handler_t) malloc(sizeof(struct req_handler));\n");
	fprintf(skel_type_fh,"\treq->req_bufcur = 0;\n");
	fprintf(skel_type_fh,"\treq->req_bufsize = size;\n");
	fprintf(skel_type_fh,"\treq->req_buf = (MPI_Request *) malloc(sizeof(MPI_Request) * req->req_bufsize);\n");
	fprintf(skel_type_fh,"\treq->statuses = (MPI_Status *) malloc(sizeof(MPI_Status) * req->req_bufsize);\n");
	fprintf(skel_type_fh,"\tfor(i=0; i<req->req_bufsize; i++)\n");
	fprintf(skel_type_fh,"\t\treq->req_buf[i] = MPI_REQUEST_NULL;\n");
	fprintf(skel_type_fh,"\t*r = req;\n");
	fprintf(skel_type_fh,"}\n\n");

	fprintf(skel_type_fh,"int add_request(req_handler_t req){\n");
	fprintf(skel_type_fh,"\tint rtn = req->req_bufcur;\n");
	fprintf(skel_type_fh,"\treq->req_bufcur++;\n");
	fprintf(skel_type_fh,"\tif(req->req_bufcur >= req->req_bufsize)\n");
	fprintf(skel_type_fh,"\t\treq->req_bufcur = 0;\n");
	fprintf(skel_type_fh,"\treturn rtn;\n");
	fprintf(skel_type_fh,"}\n\n");

	fprintf(skel_type_fh,"void find_requests(req_handler_t req, int count, int *indices, MPI_Request **requests){\n");
	fprintf(skel_type_fh,"\tint i=0;\n");
	fprintf(skel_type_fh,"\t*requests = (MPI_Request *)malloc(sizeof(MPI_Request) * count);\n");
	fprintf(skel_type_fh,"\tfor(i=0; i<count; i++)\n");
	fprintf(skel_type_fh,"\t\tif(indices[i] != -1)\n");
	fprintf(skel_type_fh,"\t\t\t(*requests)[i] = req->req_buf[(req->req_bufcur + indices[i]) % req->req_bufsize];\n");
	fprintf(skel_type_fh,"\t\telse\n");
	fprintf(skel_type_fh,"\t\t\t(*requests)[i] = MPI_REQUEST_NULL;\n");
	fprintf(skel_type_fh,"}\n\n");

	fprintf(skel_type_fh,"int reset_req(req_handler_t req, int *req_indices, int count){\n");
	fprintf(skel_type_fh,"\tint i;\n");
	fprintf(skel_type_fh,"\tfor(i=0; i<count; i++)\n");
	fprintf(skel_type_fh,"\t\tif(req_indices[i] != -1)\n");
	fprintf(skel_type_fh,"\t\t\treq->req_buf[(req->req_bufcur + req_indices[i]) % req->req_bufsize] = MPI_REQUEST_NULL;\n");
	fprintf(skel_type_fh,"}\n\n");

	fprintf(skel_type_fh,"void finalize_req(req_handler_t req){\n");
	fprintf(skel_type_fh,"\tfree(req->req_buf);\n");
	fprintf(skel_type_fh,"\treq->req_buf = NULL;\n");
	fprintf(skel_type_fh,"\tfree(req->statuses);\n");
	fprintf(skel_type_fh,"\treq->req_bufsize = 0;\n");
	fprintf(skel_type_fh,"\treq->req_bufcur = 0;\n");
	fprintf(skel_type_fh,"\tfree(req);\n");
	fprintf(skel_type_fh,"}\n");
}

/* The follow function was implemented by Vivek and removed by Xing,
 * looks like the recursive buffer based request handle management
 * approach was not correctly implemented by the following function.
 * A newer version done by Xing is the one above.*/
/*
void generate_req_handler_function(FILE* skel_type_fh){
	fprintf(skel_type_fh,"void init_req(req_handler_t * r, int size)\n");
	fprintf(skel_type_fh,"{\n");
	fprintf(skel_type_fh,"  req_handler_t req;\n");
	fprintf(skel_type_fh,"  int i;\n");

	fprintf(skel_type_fh,"  req = (req_handler_t) malloc (sizeof(struct req_handler));\n");

	fprintf(skel_type_fh,"  req->req_bufcur = 0;\n");
	fprintf(skel_type_fh,"  req->req_bufsize = size;\n");
	fprintf(skel_type_fh,"  req->req_buf = (MPI_Request *) malloc(sizeof(MPI_Request) * req->req_bufsize);\n");
	fprintf(skel_type_fh,"  req->statuses = (MPI_Status *) malloc(sizeof(MPI_Status) * req->req_bufsize);\n");
	fprintf(skel_type_fh,"  for(i = 0; i < req->req_bufsize; i++)\n");
	fprintf(skel_type_fh,"    req->req_buf[i] = MPI_REQUEST_NULL;\n");

	fprintf(skel_type_fh,"  *r = req;\n");
	fprintf(skel_type_fh,"}\n");
	fprintf(skel_type_fh,"int add_request(req_handler_t req)\n");
	fprintf(skel_type_fh,"{\n");
	fprintf(skel_type_fh,"   int pos,i,done;\n");
	fprintf(skel_type_fh,"   pos = req->req_bufcur;\n");
	fprintf(skel_type_fh,"   done = 0;\n");
	fprintf(skel_type_fh,"   for(i = pos+1; i < req->req_bufsize; i++)\n");
	fprintf(skel_type_fh,"   {\n");
	fprintf(skel_type_fh,"      if(req->req_buf[i]==MPI_REQUEST_NULL){\n");
	fprintf(skel_type_fh,"         done = 1;\n");
	fprintf(skel_type_fh,"         break;\n");
	fprintf(skel_type_fh,"      }\n");
	fprintf(skel_type_fh,"   }\n");
	fprintf(skel_type_fh,"   if(done==0)\n");
	fprintf(skel_type_fh,"   {\n");
	fprintf(skel_type_fh,"      for(i = 0; i < pos; i++)\n");
	fprintf(skel_type_fh,"      {\n");
	fprintf(skel_type_fh,"        if(req->req_buf[i]==MPI_REQUEST_NULL){\n");
	fprintf(skel_type_fh,"          done = 1;\n");
	fprintf(skel_type_fh,"          break;\n");
	fprintf(skel_type_fh,"        }\n");
	fprintf(skel_type_fh,"      }\n");
	fprintf(skel_type_fh,"   }\n");
	fprintf(skel_type_fh,"   if(done==0)\n");
	fprintf(skel_type_fh,"   {\n");
	fprintf(skel_type_fh,"     printf(\"ERROR: BUFFER IS SMALL.\\n\");\n");
	fprintf(skel_type_fh,"     exit;\n");
	fprintf(skel_type_fh,"   }\n");
	fprintf(skel_type_fh,"   req->req_bufcur = i;\n");
	fprintf(skel_type_fh,"   return pos;\n");
	fprintf(skel_type_fh,"}\n");
	fprintf(skel_type_fh,"void reset_req(req_handler_t req,int offset,int count)\n");
	fprintf(skel_type_fh,"{\n");
	fprintf(skel_type_fh,"int pos,i;\n");
	fprintf(skel_type_fh,"pos = req->req_bufsize - (offset + 1);\n");
	fprintf(skel_type_fh,"if(pos < req->req_bufcur)\n");
	fprintf(skel_type_fh,"   req->req_bufcur = pos;\n");
	fprintf(skel_type_fh,"for(i=0;i<count;i++)\n");
	fprintf(skel_type_fh,"{\n");
	fprintf(skel_type_fh,"   req->req_buf[pos]= MPI_REQUEST_NULL;\n");
	fprintf(skel_type_fh,"   pos++;\n");
	fprintf(skel_type_fh,"}\n");
	fprintf(skel_type_fh,"}\n");

	fprintf(skel_type_fh,"void finalize_req(req_handler_t req)\n");
	fprintf(skel_type_fh,"{\n");
	fprintf(skel_type_fh,"  free(req->req_buf);\n");
	fprintf(skel_type_fh,"  req->req_buf = NULL;\n");
	fprintf(skel_type_fh,"  free(req->statuses);\n");
	fprintf(skel_type_fh,"  req->req_bufsize = 0;\n");
	fprintf(skel_type_fh,"  req->req_bufcur = 0;\n");
	fprintf(skel_type_fh,"  free(req);\n");
	fprintf(skel_type_fh,"}\n");
}*/

/*
 * Generate wrappers for point-point MPI routines
 * */
void generate_p2p_ops(FILE *skel_type_fh){
  fprintf(skel_type_fh, "\
\n\nvoid do_isend(void* buffer, MPI_Datatype datatype, char* ccounts, char* cdests, \n\
\t\t\t\tint tag, MPI_Comm comm, req_handler_t req, int myrank, int comm_size){\n\
\tint count, dest, req_id;\n\
\tevent_param_t* event_param = event_params + prev_event;\n\
\tcount = get_param_val(myrank, ccounts, &(event_param->param[COUNT]));\n\
\tdest = get_param_val(myrank, cdests, &(event_param->param[DEST]));\n\
\tdest = (dest + myrank + comm_size) %% comm_size;\n\
\treq_id = add_request(req);\n\
\tassert(MPI_Isend(buffer, count, datatype, dest, tag, comm, &(req->req_buf[req_id])) == MPI_SUCCESS);\n\
}\n\
");

  fprintf(skel_type_fh, "\
\n\nvoid do_send(void* buffer, MPI_Datatype datatype, char* ccounts, char* cdests,\n\
\t\t\t\tint tag, MPI_Comm comm, int myrank, int comm_size){\n\
\tint count, dest;\n\
\tevent_param_t* event_param = event_params + prev_event;\n\
\tcount = get_param_val(myrank, ccounts, &(event_param->param[COUNT]));\n\
\tdest = get_param_val(myrank, cdests, &(event_param->param[DEST]));\n\
\tdest = (dest + myrank + comm_size) %% comm_size;\n\
\tassert(MPI_Send(buffer, count, datatype, dest, tag, comm) == MPI_SUCCESS) ;\n\
}\n\
");

  fprintf(skel_type_fh, "\
\n\nvoid do_irecv(void* buffer, MPI_Datatype datatype, char* ccounts, char* csources,\n\
\t\t\t\tint tag, MPI_Comm comm, req_handler_t req, int myrank, int comm_size){\n\
\tint count, source, req_id;\n\
\tevent_param_t* event_param = event_params + prev_event;\n\
\tcount = get_param_val(myrank, ccounts, &(event_param->param[COUNT]));\n\
\tsource = get_param_val(myrank, csources, &(event_param->param[SOURCE]));\n\
\tif(source == 2147483647)\n\
\t\tsource = MPI_ANY_SOURCE;\n\
\telse\n\
\t\tsource = (source + myrank + comm_size) %% comm_size;\n\
\treq_id = add_request(req);\n\
\tassert(MPI_Irecv( buffer, count, datatype, source, tag, comm, &(req->req_buf[req_id])) == MPI_SUCCESS);\n\
}\n\
");

  fprintf(skel_type_fh, "\
\n\nvoid do_recv(void* buffer, MPI_Datatype datatype, char* ccounts, char* csources,\n\
\t\t\t\tint tag, MPI_Comm comm, MPI_Status *status, int myrank, int comm_size){\n\
\tint count, source;\n\
\tevent_param_t* event_param = event_params + prev_event;\n\
\tcount = get_param_val(myrank, ccounts, &(event_param->param[COUNT]));\n\
\tsource = get_param_val(myrank, csources, &(event_param->param[SOURCE]));\n\
\tif(source == 2147483647)\n\
\t\tsource = MPI_ANY_SOURCE;\n\
\telse\n\
\t\tsource = (source + myrank + comm_size) %% comm_size;\n\
\tassert(MPI_Recv(buffer, count, datatype, source, tag, comm, status) == MPI_SUCCESS);\n\
}\n\
");

  fprintf(skel_type_fh, "\
\n\nvoid do_waitall(char *cwaits, req_handler_t req, int myrank){\n\
\tint *waits = get_param_val_list(myrank, cwaits);\n\
\tMPI_Status *statuses = (MPI_Status *)malloc(sizeof(MPI_Status) * waits[0]);\n\
\tMPI_Request *requests;\n\
\tfind_requests(req, waits[0], waits+1, &requests);\n\
\tassert(MPI_Waitall(waits[0], requests, statuses) == MPI_SUCCESS);\n\
\treset_req(req, waits+1, waits[0]);\n\
\tfree(waits);\n\
\tfree(requests);\n\
\tfree(statuses);\n\
}\n\
");

  fprintf(skel_type_fh, "\
\n\nvoid do_wait(char *cwaits, req_handler_t req, int myrank){\n\
\tMPI_Status status;\n\
\tMPI_Request *request;\n\
\tevent_param_t* event_param = event_params + prev_event;\n\
\tint wait = get_param_val(myrank, cwaits, &(event_param->param[REQUEST]));\n\
\tfind_requests(req, 1, &wait, &request);\n\
\tassert(MPI_Wait(request, &status) == MPI_SUCCESS);\n\
\treset_req(req, &wait, 1);\n\
\tfree(request);\n\
}\n\
");
}


/*
 * Generate wrappers for MPI collectives
 * */
void generate_collectives(FILE *skel_type_fh){

  fprintf(skel_type_fh, "\
\n\nvoid do_comm_split(MPI_Comm comm, char* ccolors, char* ckeys,\n\
\t\t\t\tMPI_Comm *newcomm, int myrank){\n\
\tevent_param_t* event_param = event_params + prev_event;\n\
\tint color = get_param_val(myrank, ccolors, &(event_param->param[COLOR]));\n\
\tint key = get_param_val(myrank, ckeys, &(event_param->param[KEY]));\n\
\tassert(MPI_Comm_split(comm, color, key, newcomm) == MPI_SUCCESS);\n\
}\n\
");

  fprintf(skel_type_fh, "\
\n\nvoid do_bcast(void *buffer, char *ccounts, MPI_Datatype datatype,\n\
\t\t\t\tint root, MPI_Comm comm, int myrank){\n\
\tevent_param_t* event_param = event_params + prev_event;\n\
\tint count = get_param_val(myrank, ccounts, &(event_param->param[COUNT]));\n\
\tassert(MPI_Bcast(buffer, count, datatype, root, comm) == MPI_SUCCESS);\n\
}\n\
");

  fprintf(skel_type_fh, "\
\n\nvoid do_allreduce(void *sendbuf, void* recvbuf, char *ccounts, MPI_Datatype datatype,\n\
\t\t\t\tMPI_Op op, MPI_Comm comm, int myrank){\n\
\tevent_param_t* event_param = event_params + prev_event;\n\
\tint count = get_param_val(myrank, ccounts, &(event_param->param[COUNT]));\n\
\tassert(MPI_Allreduce(sendbuf, recvbuf, count, datatype, op, comm) == MPI_SUCCESS);\n\
}\n\
");

  fprintf(skel_type_fh, "\
\n\nvoid do_reduce(void *sendbuf, void* recvbuf, char *ccounts, MPI_Datatype datatype,\n\
\t\t\t\tMPI_Op op, int root, MPI_Comm comm, int myrank){\n\
\tevent_param_t* event_param = event_params + prev_event;\n\
\tint count = get_param_val(myrank, ccounts, &(event_param->param[COUNT]));\n\
\tassert(MPI_Reduce(sendbuf, recvbuf, count, datatype, op, root, comm) == MPI_SUCCESS);\n\
}\n\
");
}

void generate_param_functions(FILE *skel_type_fh){
  fprintf(skel_type_fh, "\
\n\nvoid init_params(){\n\
\tevent_params = (event_param_t*) malloc(sizeof(event_param_t) * MAX_NUM_EVENTS);\n\
\tloops = (param_t*) malloc(sizeof(param_t) * MAX_NUM_LOOPS);\n\
\tmems = (param_t*) malloc(sizeof(param_t) * MAX_NUM_LOOPS);\n\
\tassert(event_params != NULL);\n\
\tassert(loops != NULL);\n\
\tassert(mems != NULL);\n\
\tmemset(event_params, 0, sizeof(event_param_t) * MAX_NUM_EVENTS);\n\
\tmemset(loops, 0, sizeof(param_t) * MAX_NUM_LOOPS);\n\
\tmemset(mems, 0, sizeof(param_t) * MAX_NUM_LOOPS);\n\
\tcur_iter = (int *)malloc(sizeof(int) * MAX_LOOP_DEPTH);\n\
\titers_len = (int *)malloc(sizeof(int) * MAX_LOOP_DEPTH);\n\
\tcur_mems = (int *)malloc(sizeof(int) * MAX_LOOP_DEPTH);\n\
\tmems_len = (int *)malloc(sizeof(int) * MAX_LOOP_DEPTH);\n\
\tassert(cur_iter != NULL);\n\
\tassert(iters_len != NULL);\n\
\tassert(cur_mems != NULL);\n\
\tassert(mems_len != NULL);\n\
\tmemset(cur_iter, 0, sizeof(int) * MAX_LOOP_DEPTH);\n\
\tmemset(iters_len, 0, sizeof(int) * MAX_LOOP_DEPTH);\n\
\tmemset(cur_mems, 0, sizeof(int) * MAX_LOOP_DEPTH);\n\
\tmemset(mems_len, 0, sizeof(int) * MAX_LOOP_DEPTH);\n\
}\n\
");

  fprintf(skel_type_fh, "\
\n\nvoid free_params(){\n\
\tint idx = 0;\n\
\tfor(idx = 0; idx < MAX_NUM_EVENTS; idx++){\n\
\t\tint param_idx = 0;\n\
\t\tfor(param_idx = 0; param_idx < MAX_PARAM_TYPE; param_idx++){\n\
\t\t\tif(event_params[idx].param[param_idx].val)\n\
\t\t\t\tfree(event_params[idx].param[param_idx].val);\n\
\t\t}\n\
\t}\n\
\tfor(idx = 0; idx < MAX_NUM_LOOPS; idx++){\n\
\t\tif(loops[idx].val)\n\
\t\t\tfree(loops[idx].val);\n\
\t\tif(mems[idx].val)\n\
\t\t\tfree(mems[idx].val);\n\
\t}\n\
\tfree(event_params);\n\
\tfree(loops);\n\
\tfree(mems);\n\
\tfree(cur_iter);\n\
\tfree(iters_len);\n\
\tfree(cur_mems);\n\
\tfree(mems_len);\n\
}\n\
");

  fprintf(skel_type_fh, "\
\n\nint* get_param_val_list(int rank, char* val_str){\n\
\tchar *iter = val_str;\n\
\tchar *pos = NULL;\n\
\tif(strchr(iter, RL_SEPARATOR) == NULL){\n\
\t\tpos = iter;\n\
\t} else {\n\
\t\tpos = iter;\n\
\t\twhile(iter && (iter = strchr(iter, PARAM_ENTRY_SEPARATOR)) != NULL){\n\
\t\t\tchar* rl_pos = strchr(pos, RL_SEPARATOR) + 1;\n\
\t\t\tif(is_member(rank, rl_pos)){\n\
\t\t\t\tbreak;\n\
\t\t\t}\n\
\t\t\titer++;\n\
\t\t\tpos = iter;\n\
\t\t}\n\
\t\tif(iter == NULL)\n\
\t\t\treturn NULL;\n\
\t}\n\
\treturn parse_val_str(pos);\n\
}\n\
");

  fprintf(skel_type_fh, "\
\n\nint get_param_val(int rank, char* val_str, param_t* param){\n\
\tint val = -1;\n\
\tif(param->val == NULL){\n\
\t\tparam->val = get_param_val_list(rank, val_str);\n\
\t}\n\
\tif(param->val){\n\
\t\tval = param->val[param->iter %% param->val[0] + 1];\n\
\t\tparam->iter++;\n\
\t}\n\
\treturn val;\n\
}\n\
");

/*
 *1. Returns iteration length if loop need to be executed now.
 *2. Returns zero if all members of any outer loop is executed except for their last iteration.
 *3. Returns one for ranks that are not part of loop.
 *4. Incase of dummy loops(iteration length = 0), member counts are updated.
 * */
  fprintf(skel_type_fh, "\
\n\nint get_iters_length(int rank, char* val_str, int loop_idx, int loop_depth){\n\
\tint idx = 0;\n\
\tfor(idx = 0; idx < (loop_depth - 1); idx++){\n\
\t\tif(cur_mems[idx] >= mems_len[idx] &&\n\
\t\tcur_iter[idx] != iters_len[idx] - 1){\n\
\t\t\treturn 0;\n\
\t\t}\n\
\t}\n\
\tint iter = get_param_val(rank, val_str, &loops[loop_idx]);\n\
\tif(iter == 0){\n\
\t\tfor(idx = 0; idx < loop_depth - 1; idx++){\n\
\t\t\tcur_mems[idx] += mems_len[loop_depth - 1];\n\
\t\t}\n\
\t}\n\
\treturn (iter >= 0) ? iter : 1;\n\
}\n\
");

/*
 *1. Returns members count if loop need to be executed now.
 *2. Returns zero if all members of any outer loop is executed except for their last iteration.
 *3. Returns zero for ranks that are not part of loop.
 * */
  fprintf(skel_type_fh, "\
\n\nint get_mems_length(int rank, char* val_str, int loop_idx, int loop_depth){\n\
\tint idx = 0;\n\
\tfor(idx = 0; idx < (loop_depth - 1); idx++){\n\
\t\tif(cur_mems[idx] >= mems_len[idx] &&\n\
\t\tcur_iter[idx] != iters_len[idx] - 1){\n\
\t\t\treturn 0;\n\
\t\t}\n\
\t}\n\
\tint mem = get_param_val(rank, val_str, &mems[loop_idx]);\n\
\treturn (mem > 0) ? mem : 0;\n\
}\n\
");
}
